<script>
import {
  GlForm,
  GlFormGroup,
  GlFormInput,
  GlButton,
  GlAlert,
} from '@gitlab/ui';
export default {
  components: {
    GlAlert,
    GlForm,
    GlFormGroup,
    GlFormInput,
    GlButton,
  },
  data() {
    return {
      login: {
        username: '',
        password: '',
      },
      errorMessage: null,
      isErrorDismissed: false,
    };
  },
  computed: {
    isErrorAlertShown() {
      return Boolean(this.errorMessage) && !this.isErrorDismissed;
    },
  },
  methods: {
    async userLogin() {
      try {
        await this.$auth.loginWith('local', {
          data: this.login,
        });
      } catch (err) {
        this.isErrorDismissed = false;
        if (err.message.includes('401')) {
          this.errorMessage = this.$options.i18n.wrongLoginCredentials;
        } else {
          this.errorMessage =
            err.message ||
            'Oops, something went terribly wrong, and we do not know what exactly';
        }
      }
    },
  },
  i18n: {
    title: 'Login',
    wrongLoginCredentials:
      'This combination of login and password is incorrect.',
  },
};
</script>
<template>
  <main
    class="container gl-mt-7 gl-mb-4 gl-display-flex gl-flex-direction-column"
  >
    <h1 class="gl-text-center">{{ $options.i18n.title }}</h1>
    <div class="gl-w-half gl-xs-w-full gl-ml-auto gl-mr-auto bargl-min-w-20">
      <gl-alert
        v-if="isErrorAlertShown"
        variant="danger"
        class="gl-mb-3"
        @dismiss="isErrorDismissed = true"
        >{{ errorMessage }}</gl-alert
      >
      <gl-form @submit.prevent="userLogin">
        <gl-form-group
          id="form-username"
          label="Username"
          label-for="input-username"
        >
          <gl-form-input
            id="form-username"
            v-model="login.username"
            type="text"
          />
        </gl-form-group>
        <gl-form-group
          id="form-password"
          label="Password"
          label-for="input-password"
        >
          <gl-form-input
            id="input-password"
            v-model="login.password"
            type="password"
          />
        </gl-form-group>
        <div class="gl-display-flex gl-justify-content-end">
          <gl-button variant="confirm" type="submit">Submit</gl-button>
        </div>
      </gl-form>
    </div>
  </main>
</template>
